typedef unsigned char	byte;
typedef unsigned short	word;
typedef unsigned int	uint;



void decrypt (word* in, word* out, word* key);
word weirdproc (word first, word second);



//  
//   -  zlib 
// 0x78, 0x9C, 0xBD, 0x7D, 0x09, 0x7C, 0x1B, 0xC7, 0x79, 0xEF, 0xEC, 0xE2, 0x20, 0x41, 0x4A, 0xF2
byte encdata[] = {	0xDB, 0x42, 0xA3, 0xC5, 0x1F, 0xD7, 0xCE, 0x05, 0xB1, 0x54, 0x6C, 0xEE, 0x6C, 0xFF, 0xEF, 0x66};

//  
byte decrkey[] = {	0x11, 0xDB, 0x80, 0xFD, 0x00, 0xFD, 0x89, 0xED, 0x00, 0x40, 0x01, 0x20, 0x08, 0x00, 0xE5, 0x7F,\
					0xFF, 0xBF, 0x52, 0xBB, 0x0F, 0x00, 0x0D, 0x60, 0x34, 0xCB, 0x20, 0xF2, 0x40, 0xFF, 0x94, 0x16,\
					0xB0, 0x07, 0xF0, 0x06, 0x97, 0x99, 0xF0, 0xFF, 0xFA, 0x9F, 0x01, 0xFE, 0x03, 0xD8, 0x00, 0x78,\
					0x89, 0x87, 0x00, 0xF8, 0x00, 0x30, 0x18, 0x5D, 0xBC, 0x01, 0x28, 0x00, 0x50, 0x5A, 0xE0, 0xFF,\
					0xFC, 0xFF, 0x92, 0x4E, 0x30, 0x00, 0x78, 0x03, 0xB5, 0x60, 0x00, 0xF0, 0x00, 0xFE, 0x9E, 0xDC,\
					0x01, 0x18, 0x00, 0xBC, 0x01, 0x00, 0x00, 0x22, 0xF8, 0xFF, 0x5A, 0x66, 0xDE, 0x00, 0x5A, 0x00,\
					0x47, 0x3A, 0x91, 0xFF, 0xF6, 0xFF, 0x56, 0x95	};



int main ()
{
	word buffer[4];
	decrypt ((word*)&encdata, buffer, (word*)&decrkey);

return 0;
}




//  /   -    ( )
void decrypt (word* input, word* output, word* key)
{
	int x, y, z = 0;

	word buf[4] = {input[0], input[1], input[2], input[3]};

	for (int i = 0; i < 8; i++)
	{
		buf[0] = weirdproc (buf[0], key[z++]);
		buf[1] += key[z++];
		buf[2] += key[z++];
		buf[3] = weirdproc (buf[3], key[z++]);

		x = weirdproc ((buf[0] ^ buf[2]), key[z++]);
		y = weirdproc (((buf[1] ^ buf[3]) + x), key[z++]);
		x += y;

		buf[0] ^= y;
		buf[3] ^= x;
		x ^= buf[1];
		buf[1] = buf[2] ^ y;
		buf[2] = x;
	}

	output[0] = weirdproc (buf[0], key[z++]);
	output[1] = buf[2] + key[z++];
	output[2] = buf[1] + key[z++];
	output[3] = weirdproc (buf[3], key[z]);

return;
}


word weirdproc (word first, word second)
{
	if (!first)	{return (1 - second);}
	if (!second) {return (1 - first);}

	uint low = first * second;
	uint high = low >> 16;
	low &= 0xFFFF;

	if (low <= high) {return (low - high + 1);}
	else {return (low - high);}
}


